rem   I2C-Monitor in Software mit PIC 16F873  
rem   Version 1.1 
rem   Ausgabe-format fr LCD-Anzeige 
rem   1. Byte im Hexformat          =Anzahl der folgenden Byte 
rem   2. Byte im Hexformat          =I2C-Empfnger-Adresse 
rem   3. bis ntes Byte im Hexformat =Daten-Byte 
rem 
rem  Im Fehlerfall erscheint im Display eine Fehlermeldung 
rem 
rem 
rem 
rem 
rem  copyright by Wolfram Harth, DF2OAG, 2002 
rem 
rem 
rem 
rem 
rem 
rem 
rem      Achtung Achtung Achtung Achtung Achtung Achtung 
rem      Nach dem Compiler-Lauf sind folgende nderungen  
rem      in der Datei *.src durchzufhren 
rem 
rem      vorher                                  neu 
rem      $$I2CS07  jb      RB,3,$$I2CS07 
rem                bsf     status,5 
rem                bcf     RC,4                  bsf     RC,4  
rem                bcf     status,5 
rem                bcf     RC,4                  bsf     RC,4 
rem      Mit dieser nderung wird das ACK verhindert 
rem 
rem 
rem      vorher                                  neu 
rem      $$I2CS18  bsf     ARG5,6 
rem                btfsc   ERG,0 
rem                bsf     ARG5,4 
rem                movf    ERG,w 
rem                andlw   0FEh                  movwf  47  
rem                xorwf   ARG3,w                Zeile lschen 
rem                jnz     $$I2CSER              Zeile lschen 
rem                jb      ARG5,4,$$I2CS07 
rem                bsf     ARG5,5 
rem                goto    $$I2CS07 
rem      Mit dieser nderung wird die Slaveadresse nicht mehr  
rem      verglichen, sondern gespeichert 
rem 
rem     Nach der nderung muss der Assembler aufgerufen werden 
rem 
rem 
rem Parameter 

         define device 16F873,hs_osc,wdt_off,adcfg7 
         xtal 20.00 


         tris ra,255 
         tris rb,0 
         tris rc,255 

         i2cinit rc,4,3,slave,adr=170,buffer=$30 
         lcdinit rb,2,20 


rem Variablen 

         define tmp = $20    'temporre Speicherzelle 
         define bzahl=$21    'Anzahl der empfangenen Byte + Adrbyte 
         define i2cadr=$2F   'I2C-Adresse 
         define data1= $30   '1. Datenbyte 
         define data2= $31   '2. Datenbyte 
         define data3= $32   '3. Datenbyte 
         define data4= $33   '4. Datenbyte 
         define data5= $34   '5. Datenbyte 
                             'Hier folgen die Speicher fr das 2. 
                             'Datenpaket in Modus 2 
         define bzahlb=$40   
         define i2cadrb=$41 
         define data1b= $42 
         define data2b= $43 
         define data3b= $44 
         define data4b= $45 
         define data5b= $46 
         define err=err_     'Errorflag zum Auswerten von Fehlern 

rem init 

         lcdwrite 1,1,"I2C-Monitor 1.0      " 
         lcdwrite 2,1,"von DF2OAG           " 
 
         gosub datclr                           'datenspeicher lschen 

start: 
         let tmp=0                              'tmp lschen 
         if rc,2=1 then goto modus1             'rc2 High= Modus 1 
         goto modus2                            'rc2 Low=  Modus 2 

modus1: 
         if rc,2=0 then goto mowe              'Moduswechsel? 
         i2cslave                              'I2C-Bus lesen 
         let bzahl=fsr-$2F             'FSR zhler fr empfange Byte 
         if err_,3=1 then goto fehler          'Falls lesen fehlerhaft 

rem hier folgt die Ausgabe der Daten auf das LCD 

  lcdwrite 1,1,bzahl,$," ",i2cadr,$," ",data1,$," ",data2,$," ",{+} 
  data3,$," ",data4,$," ",data5,$
         inc tmp                  'Ereigniszhler +1 
         lcdwrite 2,1,tmp         'Ereigniszhler Ausgabe LCD 2. Zeile 
         gosub datclr             'Datenbereich lschen 
         goto modus1              'Modus 1 von vorn beginnen 
fehler:                           'Fehleranzeige 
         gosub lcdclr             'LCD lschen  
         lcdwrite 1,1,"Fehler beim Lesen    "  'Fehler Ausgabe auf LCD 
         goto start                            'von vorn beginnen 


datclr:                           'Datenvariablen lschen 

         let data1=0 
         let data2=0 
         let data3=0 
         let data4=0 
         let data5=0 
         let data1b=0 
         let data2b=0 
         let data3b=0 
         let data4b=0 
         let data5b=0 
         return 

lcdclr:                                'Lsche die LC-Anzeige 
         lcdwrite 1,1,"                     " 
         lcdwrite 2,1,"                     " 
         return 


modus2: 
         if rc,2=1 then goto mowe    'Moduswechsel? 
         gosub modus2a          'I2C-Bus beobachten 
         if err_,3=1 then goto fehler 'Fehleranzeige 
         gosub modus2s          'Ergebnis speichern fr 2. Abfrage 
         gosub modus2a          'I2C-Bus beobachten 
         if err_,3=1 then goto fehler 'Fehleranzeige 

rem hier folgt die Ausgabe der Daten auf das LCD 

 lcdwrite 1,1,bzahlb,$," ",i2cadrb,$," ",data1b,$," ",data2b,$," ",{+} 
 data3b,$," ",data4b,$," ",data5b,$

  lcdwrite 2,1,bzahl,$," ",i2cadr,$," ",data1,$," ",data2,$," ",{+} 
  data3,$," ",data4,$," ",data5,$
         gosub datclr                  'lsche Datenbereich 
         goto modus2                   'Modus 2 von vorn beginnen 
modus2a:                               'I2C-Bus lesen 
         i2cslave 
         let bzahl=fsr-$2F             'FSR zhler fr empfange Byte 
         return 
modus2s:                      'Ergebnis in die "b" Variable speichern 
         let bzahlb =bzahl 
         let i2cadrb=i2cadr 
         let data1b =data1 
         let data2b =data2 
         let data3b =data3 
         let data4b =data4 
         let data5b =data5 
         return 
mowe:                               'Wechsel des Modus, LCD lschen 
         gosub lcdclr                           'LCD lschen 
         goto start 
end 



